(function(){
	function parseParams(data) {
        try {
            var tempArr = [];
            for (var i in data) {
                var key = encodeURIComponent(i);
                var value = encodeURIComponent(data[i]);
                tempArr.push(key + '=' + value);
            }
            var urlParamsStr = tempArr.join('&');
            return urlParamsStr;
        } catch (err) {
            return '';
        }
    }


	function getResId(){
        function WosPost(url, data){
            var _data = '';
            jQuery.ajax({
                type: "POST",
                url: url,
                dataType: "html",
                data: JSON.stringify(data),
                async: false,
                headers:{"x-1p-wos-sid":localStorage.getItem("wos_sid")},
                contentType: "application/json",
                beforeSend:function(){
                    showLoading();
                },
                success: function(data){
                    _data = data;
                },
                error: function(){
                    console.log('get data info error.');
                }
            }); 
            return _data;       
        }
		// var id = window.location.pathname.split('/').pop();
        var id = window.location.pathname.match("full-record\/([^(]+)")[1];
        // var id = jQuery('#HiddenSecTa-accessionNo').text()    

        var data = {
            "ids": [id],
            "displayTimesCited": "true",
            "displayCitedRefs": "true",
            "product": "UA",
            "colName": "WOS",
            "displayUsageInfo": "true",
            "fileOpt": "othersoftware",
            "action": "saveToTab",
            "locale": "zh_CN",
            "view": "fullrec",
            "fieldList": [
                "AUTHORS",
                "TITLE",
                "SOURCE",
                "CONFERENCE_INFO",
                "CITTIMES",
                "ACCESSION_NUM",
                "AUTHORSIDENTIFIERS",
                "ISSN",
                "PMID",
                "ABSTRACT",
                "ADDRS",
                "AFFILIATIONS",
                "DOCTYPE",
                "KEYWORDS",
                "JCR_CATEGORY",
                "SUBJECT_CATEGORY",
                "WOS_EDITIONS",
                "CITREF",
                "CITREFC",
                "USAGEIND",
                "HOT_PAPER",
                "HIGHLY_CITED",
                "FUNDING",
                "PUBINFO",
                "OPEN_ACCESS",
                "PAGEC",
                "SABBR",
                "IDS",
                "LANG",
            ],
        }

		console.log("data",data);
        //导出为ris格式
        var url = '/api/wosnx/indic/export/saveToFile';
        console.log(url, data);
        var content = WosPost(url, data);
        console.log(content);
        // var ParserContent = Parser_WOS_CSV(content)
        

        var ParserContent = Parser_WOS_CSV(content.trim())
        ParserDetailsJson(ParserContent)
	}


    function Parser_WOS_CSV(CSV) {
        function ParserWOSjsonContent(res) {
            function behasKey(json, key) {
                if (json.hasOwnProperty(key)) {
                    return true;
                } else {
                    return false;
                }
            }
            function getSingleData(key, raw) {
                if (behasKey(raw, key)) {
                    return raw[key].replace("            ", " ");;
                } else {
                    return '';
                }
            }

            function get_default() {
                let ref = {}
                ref['Title'] = getSingleData("TI", res);
                ref['Author'] = getSingleData("AU", res);
                ref['Abstract'] = getSingleData("AB", res);
                ref['Keywords'] = getSingleData("DE", res);
                ref['Author Address'] = getSingleData("C1", res);
                ref['DOI'] = getSingleData("DI", res);
                ref['Pages'] = getSingleData("BP", res);
                if (behasKey(res, "EP")) {
                    if (ref['Pages'] != undefined && ref['Pages'] != "") {
                        ref['Pages'] = ref['Pages'] + "-" + getSingleData("EP", res);
                    } else {
                        ref['Pages'] = getSingleData("EP", res);
                    }
                }

                ref['Issue'] = getSingleData("IS", res);
                ref['Language'] = getSingleData("LA", res);
                ref['ISBN/ISSN'] = getSingleData("SN", res);
                ref['Journal'] = getSingleData("SO", res);
                ref['Year'] = getSingleData("PY", res);
                ref['Volume'] = getSingleData("VL", res);

                if (behasKey(res, "UT")) {
                    ref["Accession Number"] = res["UT"];
                    ref["URL"] = 'https://www.webofscience.com/wos/alldb/full-record/' + res["UT"]
                }
                ref['Original Publication'] = getSingleData("PU", res);
                ref['Place Published'] = getSingleData("PA", res);
                ref['Tertiary Author'] = getSingleData("BE", res);
                ref['Secondary Title'] = getSingleData("SO", res);
                ref['Short Title'] = getSingleData("CA", res);
                return ref;
            }

            function get_journal(res) {
                let ref = get_default();
                ref['Reference Type'] = "Journal Article";
                return ref;
            }

            function get_book_section(res) {
                let ref = get_default();
                ref['Reference Type'] = "Book Section";
                ref['Tertiary Title'] = getSingleData("SE", res);
                return ref;
            }
            function get_patent(res) {
                let ref = get_default();
                ref['Reference Type'] = "Patent";
                ref['Issue'] = getSingleData("PN", res);
                ref['Subsidiary Author'] = getSingleData("AE", res);

                return ref;

            }
            function get_conference(res) {
                let ref = get_default();
                ref['Reference Type'] = "Conference Paper";
                ref['Place Published'] = getSingleData("CL", res);
                return ref;
            }

            function change_type(type, res) {
                switch (type) {
                    case "J":
                        return get_journal(res);
                    case "B":
                        return get_book_section(res);
                    case "S":
                        return get_book_section(res);
                    case "P":
                        return get_patent(res);
                    case "C":
                        return get_conference(res);
                    default:
                        return get_journal(res);
                }
            }

            if (behasKey(res, "PT")) {
                ref = change_type(res["PT"], res);
                ref['Database Provider'] = 'Web of Science';
                return ref;
            } else {
                return {};
            }
        }

        function clear_space(raw_array) {
            let res_arr = [];
            for (let raw_num = 0; raw_num < raw_array.length; raw_num++) {
                res_arr.push(raw_array[raw_num].trim());
            }
            return res_arr;
        }

        //将CSV分割存为Json格式；
        let res_array = [];
        let row_array = CSV.split(/\u000A/g);
        let column_name_array = clear_space(row_array.shift().split(/\u0009/g));
        if (column_name_array[0] == "PT") {
            for (let row_num = 0; row_num < row_array.length; row_num++) {
                if (row_array[row_num] != undefined && row_array[row_num] != "") {
                    let row = row_array[row_num].split(/\u0009/g);
                    let res = {};
                    clear_row = clear_space(row);
                    for (let i = 0; i < row.length; i++) {
                        if (row[i] == "") {
                            continue;
                        }
                        res[column_name_array[i]] = row[i];
                    }
                    res_array.push(ParserWOSjsonContent(res));
                }
            }
            return res_array;
        }
    }
    showLoading();
    var checkDom = setInterval(function(){
        if(jQuery('#gettingContentBlock_pNE').is(':visible')){
            clearInterval(checkDom);
            try{
              getResId();
            } catch (error) {
                ParserDetailsJson([]);
            }
            jQuery('.operateRowBlock_pNE').html('')
        }
    },300);
	
	})()