(function(){
	// 根据标签文本内容查找标签
	function getEleByText(targetStr){
		return jQuery(`td:contains(${targetStr})`);
	}
	// 获取页面NE数据网页信息
	function getNEPageInfo(){
		var pageData = '';
		var articleIdStr = jQuery(".icon-output").attr("onclick").trim().trim(')').split(',')[1];
		var sendDataStr = articleIdStr.substr(1,articleIdStr.length-2);
		jQuery.ajax({
			type: "POST",
	        url: 'https://kns.cnki.net/kns/ViewPage/viewsave.aspx?displayMode=NoteExpress',
	        dataType: "html",
	        data: {formfilenames:sendDataStr},
	        async: false,
	        success: function(data){
	        	pageData = data;
	        },
	        error: function(){
	            console.log('get data info error.');
	        }
		});
		return pageData;
	}
	// 将网页NE转换成JSON格式
	function NEPageToNEJson(){
		var sendJsonArr = [];
		var NEJson = {};
		if(location.href.match('dbcode=SCPD')){
			NEJson['Reference Type'] = 'Patent';
			NEJson['Title']=jQuery('Title').text().split('--')[0];
			NEJson['Subsidiary Author'] = jQuery.trim(getEleByText('【申请人】').next().text());
			NEJson['Author Address'] = jQuery.trim(getEleByText('【地址】').next().text());
			NEJson['Issue'] = jQuery.trim(getEleByText('【申请号】').next().text());
			NEJson['Date'] = jQuery.trim(getEleByText('【申请日】').next().text());
			NEJson['Year'] = NEJson['Date'].substr(0,4);
			NEJson['Author'] = jQuery.trim(getEleByText('【发明人】').next().text());
			NEJson['Number'] = jQuery.trim(getEleByText('【公开号】').next().text());
			NEJson['Volume'] = jQuery.trim(getEleByText('【公开号】').next().text());
			NEJson['Reviewed Item'] = jQuery.trim(getEleByText('【公开日】').next().text());
			NEJson['Subject Headings'] = jQuery.trim(getEleByText('【公开日】').next().text());
			NEJson['Author Affiliation'] = jQuery.trim(getEleByText('【专利代理机构】').next().text());
			NEJson['Secondary Author'] = jQuery.trim(getEleByText('【代理人】').next().text());
			NEJson['Country'] = jQuery.trim(getEleByText('【国省代码】').next().text());
			NEJson['Abstract'] = jQuery.trim(getEleByText('【摘要】').next().text());
			NEJson['Subject'] = jQuery.trim(getEleByText('【主权项】').next().text());
			NEJson['Category'] = jQuery.trim(getEleByText('【主分类号】').next().text());
			NEJson['Category'] = jQuery.trim(getEleByText('【主分类号】').next().text());
			NEJson['Database Provider']='中国知网';
			NEJson['URL'] = location.href;
		}else{
			var pageData = getNEPageInfo();
			var dataStr = pageData.split('font-size:9pt">')[1].split('</td>')[0];
			var dataRowArr = dataStr.split('<br>');
			var rowArr = [];
			
			for(var i = 0 ; i < dataRowArr.length ; i++){
				if(dataRowArr[i] == ''){
					continue;
				}
				rowArr = dataRowArr[i].split(': ');
				NEJson[rowArr[0].split('{')[1].split('}')[0]] = jQuery.trim(rowArr[1]);
			}
		}
		console.log(NEJson);
		sendJsonArr.push(NEJson);
		return sendJsonArr;
	}

	if(jQuery('#pdfDown').length == 0 && jQuery('.a05:contains(推荐下载阅读CAJ格式全文)').length == 0 && jQuery('.icon-dlGreen:contains(整本下载)').length==0){
		jQuery('.operateRowBlock_pNE').html('');
	}
	// 显示加载页
	showLoading();	
    var checkDom = setInterval(function(){
		if(jQuery('#gettingContentBlock_pNE').is(':visible')){
			clearInterval(checkDom);
			var pureJson = '';
			pureJson = NEPageToNEJson();
			for(var i = 0 ; i < pureJson.length ; i++){
				switch(pureJson[i]['Reference Type']){
					case 'Thesis':
						pureJson[i]['Volume']=pureJson[i]['Type of Work'];
					break;
					case 'Journal Article':
						pureJson[i]['Tertiary Title']=pureJson[i]['Translated Title'];
					break;
					case 'Conference Proceedings':
						pureJson[i]['Reference Type']='Conference Paper';
						pureJson[i]['Publisher']=pureJson[i]['Subsidiary Author'];
					break;
				}
				pureJson[i]['URL']=location.href;
			}
			ParserDetailsJson(pureJson);
		}
	},300);
    jQuery('#saveBlock_pNE').bind('click',function(){
		if(jQuery('.downloadFullEle_pNE[name="downloadFull_pNE"]').is(':checked')){
			if(jQuery('#pdfDown').length != 0){
				jQuery('#pdfDown')[0].click();
			}else if(jQuery('.a05:contains(推荐下载阅读CAJ格式全文)').length != 0){
				jQuery('.a05:contains(推荐下载阅读CAJ格式全文)')[0].click();
			}else if(jQuery('.icon-dlGreen:contains(整本下载)').length != 0){
				jQuery('.icon-dlGreen:contains(整本下载)')[0].click();
			}else{
				console.log('noDownload link');
			}
		}
	})
})();		