(function () {

    // 显示加载页
    showLoading();  
    var checkDom = setInterval(function(){
        if(jQuery('#gettingContentBlock_pNE').is(':visible')){
            clearInterval(checkDom);
            var data = getResId();
            ParserDetailsJson(data);
        }
    },300);

 

	function doPost(url, data) {
		var _data = '';
		jQuery.ajax({
			type: "POST",
			url: url,
			dataType: "html",
			data: JSON.stringify(data),
			async: false,
 
			contentType: "application/json",
			beforeSend: function () {
				showLoading();
			},
			success: function (data) {
				console.log(2);
				_data = data;
			},
			error: function () {
				console.log('get data info error.');
			}
		});
		return _data;
	}
	
 

    function getResId() {
  
		var pageType = getUrlParam("pageType")
		pageType = pageType == null ? '1' : pageType

		const urlParams = new URLSearchParams(window.location.search);

		// 从URL参数中提取id和typename
		const lngid = urlParams.get('id');
		const type = urlParams.get('typename');

        var postdata = {
                'lngid': lngid,
                'type': type,
                'pageType': pageType
            }

        url = 'https://www.ncpssd.cn/articleinfoHandler/getjournalarticletable';
		
		console.log(1);
        var content = doPost(url, postdata);
        console.log(content);


		var postData = [];
		var NE = {};

		
		//content 是json字符串，判断result是否等于true
		const parsedContent = JSON.parse(content);
		if (parsedContent && parsedContent.result === true) {
		    // 逻辑代码
 
			NE['Reference Type'] = 'Journal Article';
			if (type == "古籍") {
				NE['Reference Type'] = 'BOOK';
			}
			if (type == "外文图书") {
				NE['Reference Type'] = 'BOOK';
			}
			if (type == "会议论文") {
				NE['Reference Type'] = 'Conference Proceedings';
			}
			if (type == "学位论文") {
				NE['Reference Type'] = 'Thesis';
			}

			data = parsedContent.data;
			NE['Title'] = data['titlec'];
			NE['Translated Title'] = data['titlee'];
			NE['Author'] = data['showwriter']; // "李木洲[1];曾思鑫[1]"
			NE['Author'] = NE['Author'].replace(/\[.*?\]/g, '');  
			NE['Translated Author'] = data['authore']; //  "[LI Muzhou[1], ZENG Sixin[1]]" --->> LIU Xueni; ZENG Sixin
			//[HU Xiaoyong[1,2], LIU Xueni[3], CHEN Lishi[3], LIU Yanfan[3], LIU Xiaohong[1]]	--->> LIU Xueni; CHEN Lishi; LIU Yanfan; LIU Xiaohong\
			if 	(data['authore']) {
				NE['Translated Author'] = data['authore'].replace(/\[.*?\]/g, ''); 
				NE['Translated Author'] = NE['Translated Author'].replace(/,\s*/g, '; ');
			} 


			NE['Year'] = data['years'];
			NE['Journal'] = data['mediac'];
			NE['Tertiary Title'] = data['mediae'];
			NE['Volume'] = data['vol'];

			// 判断是否为全零字符串（包含数字0和字符串"0","00","000"等情况）
			if (/^0+$/.test(String(NE['Volume']))) {
				NE['Volume'] = ''; // 赋值为空字符串
			}

			NE['Issue'] = data['num'];
			NE['Pages'] = data['beginpage'] + '-' + data['endpage'];
			NE['DOI'] = data['doi'];
			NE['ISBN/ISSN'] = data['issn'];
			NE['Keywords'] = data['keywordc'];
			NE['Abstract'] = data['remarkc'];
			NE['Translated Abstract'] = data['remarke'];
			NE['Author Affiliation'] = data['showorgan']; //"[1]东北师范大学历史文化学院",
			NE['Subject Category'] = data['clazz'].replace('[', '').replace(']', '');

		}

        NE['Database Provider'] = 'NCPSSD';

        postData.push(NE);

		var replace = document.querySelector('#replace');
		//判断replace是否存在，并且判断是否包含 onclick="loginOut()"

 


		if (replace && replace.innerHTML.includes('退出登录')) {
            jQuery('#saveBlock_pNE').bind('click', function () {
                if (jQuery('.downloadFullEle_pNE[name="downloadFull_pNE"]').is(':checked')) {
					//<a id="a_down" class="all-down pointer">全文下载</a>
					console.log('click');
                    jQuery('#a_down').click();
				} else {
					console.log('no click');
				}
            })
		} else {
			jQuery('.operateRowBlock_pNE').html('');
		    console.log('Element does not exist or does not contain onclick="loginOut()"');
		}

		return postData;
	}

})()