(function(){
	// 获取数据
	function getDetailData(){
		var detailData = '';
		jQuery.ajax({
			type: "GET",
	        url: jQuery.trim(jQuery('[style="color:black;"]').attr('href')),
	        dataType: "text",
	        async: false,
	        success: function(data){
	        	detailData = data;
	        },
	        error: function(){
	            console.log('get data info error.');
	        }
		});
		return detailData;
	}
	// 将获取数据专程JSON格式
	function detailDataToJson(){
		var sendJsonArr = [];
		var NEJson = {};
		
		var pageData = getDetailData();
		var dataArr = pageData.split('\n');
		var rowArr = [];

		NEJson['URL'] = location.href;


		switch(jQuery.trim(jQuery('[style="color:black;"]').attr('href').split('dbname=')[1].split('&')[0])){
			case 'lw':
				NEJson['Reference Type'] = 'Thesis';
				NEJson['Database Provider'] = '北京协和医学院博硕学位论文库';
				NEJson['Title'] = jQuery.trim(jQuery('#message').parents('tr').next().find('input').val());
				for(var i = 1; i < dataArr.length ; i++){
					if(dataArr[i] == ''){
						continue;
					}
					rowArr = dataArr[i].split('】:');
					switch(rowArr[0].split('【')[1]){
						case '英文标题':
							NEJson['Translated Title'] = jQuery.trim(rowArr[1]);
						break;
						case '研究生姓名':
							NEJson['Author'] = jQuery.trim(rowArr[1]);
						break;
						case '出版时间':
							NEJson['Year'] = jQuery.trim(rowArr[1]).substr(0,4);
						break;
						case '页码':
							NEJson['Pages'] = jQuery.trim(rowArr[1]);
						break;
						case '授予学位':
							NEJson['Volume'] = jQuery.trim(rowArr[1]);
						break;
						case '授予学位单位':
							NEJson['Publisher'] = jQuery.trim(rowArr[1]);
						break;
						case '导师':
							NEJson['Tertiary Author'] = jQuery.trim(rowArr[1]);
						break;
						case '研究专业':
							NEJson['Section'] = jQuery.trim(rowArr[1]);
						break;
						case '分类号':
							NEJson['Category'] = jQuery.trim(rowArr[1]);
						break;
						case '关键词':
							var re = new RegExp(';','g');
							NEJson['Keywords'] = jQuery.trim(rowArr[1]).replace(re,'; ');
						break;
						case '中文摘要':
							var absRe = new RegExp('(<p>|</p>|\n)','g');
							NEJson['Abstract'] = jQuery.trim(rowArr[1]).replace(absRe,'');
						break;
						case '英文摘要':
							if(NEJson['Abstract']){
								var absRe2 = new RegExp('(<p>|</p>|\n)','g');
								NEJson['Abstract'] =NEJson['Abstract'] + '\n' + jQuery.trim(rowArr[1]).replace(absRe2,'');
							}
						break;
					}
				}
			break;
			case 'zh':
				NEJson['Reference Type'] = 'Journal Article';
				NEJson['Database Provider'] = '中国生物医学文献数据库';
				for(var i = 1; i < dataArr.length ; i++){
					if(dataArr[i] == ''){
						continue;
					}
					rowArr = dataArr[i].split('】:');
					switch(rowArr[0].split('【')[1]){
						case '流水号':
						break;
						case '标题':
							NEJson['Title'] = jQuery.trim(rowArr[1]);
						break;
						case '英文标题':
							NEJson['Translated Title'] = jQuery.trim(rowArr[1]);
						break;
						case '作者':
							NEJson['Author'] = jQuery.trim(rowArr[1]);
						break;
						case '作者单位':
							NEJson['Author Affiliation'] = jQuery.trim(rowArr[1]);
						break;
						case '出处':
							var regex1 = /\(/;
							var regex2 = /\)/;
							var jourName = jQuery.trim(rowArr[1]).split(' ')[0];
							var shitInfo = jQuery.trim(rowArr[1]).split(' ')[1];
							NEJson['Journal'] = jourName;
							NEJson['Year'] = shitInfo.substr(0,4);
							NEJson['Volume'] = (shitInfo.split(';')[1].match(regex1) || !(shitInfo.split(';')[1].match('-')))?shitInfo.split(';')[1].split('(')[0]:'';
							NEJson['Issue'] = (shitInfo.match(regex1))?shitInfo.split('(')[1].split(')')[0]:'';
							NEJson['Pages'] = (shitInfo.split(';')[shitInfo.split(';').length-1].match('-') || !(shitInfo.split(';')[shitInfo.split(';').length-1].match(regex1)))?shitInfo.split(';')[shitInfo.split(';').length-1]:'';
						break;
						case '国际期刊代码':
							NEJson['ISBN/ISSN'] = jQuery.trim(rowArr[1]);
						break;
						case '关键词':
							var re = new RegExp(';','g');
							NEJson['Keywords'] = jQuery.trim(rowArr[1]).replace(re,'; ');
						break;
						case '摘要':
							NEJson['Abstract'] = jQuery.trim(rowArr[1]);
						break;
					}
				}
			break;
			case 'kp':
				NEJson['Reference Type'] = 'Journal Article';
				NEJson['Database Provider'] = '中国医学科普文献数据库';
				NEJson['Title'] = jQuery.trim(jQuery('#message').parents('tr').next().find('input').val());
				for(var i = 1; i < dataArr.length ; i++){
					if(dataArr[i] == ''){
						continue;
					}
					rowArr = dataArr[i].split('】:');
					switch(rowArr[0].split('【')[1]){
						case '流水号':
						break;
						case '标题':
							NEJson['Title'] = jQuery.trim(rowArr[1]);
						break;
						case '英文标题':
							NEJson['Translated Title'] = jQuery.trim(rowArr[1]);
						break;
						case '作者':
							NEJson['Author'] = jQuery.trim(rowArr[1]);
						break;
						case '作者单位':
							NEJson['Author Affiliation'] = jQuery.trim(rowArr[1]);
						break;
						case '出处':
							var regex1 = /\(/;
							var regex2 = /\)/;
							var jourName = jQuery.trim(rowArr[1]).split(' ')[0];
							var shitInfo = jQuery.trim(rowArr[1]).split(' ')[1];
							NEJson['Journal'] = jourName;
							NEJson['Year'] = shitInfo.substr(0,4);
							if(shitInfo.split(';').length == 3){
								// 标准格式中，判断是否有期
								if(shitInfo.split(';')[1].match(regex1)){
									NEJson['Volume']=shitInfo.split(';')[1].split('(')[0];
								}else{
									NEJson['Volume']=shitInfo.split(';')[1];
								}
							}else if(shitInfo.split(';').length == 2){
								// 非标准格式中，判断期的位置
								if(shitInfo.split(';')[1].match(regex1)){
									NEJson['Volume']=shitInfo.split(';')[1].split('(')[0];
								}else{
									NEJson['Volume']='';
								}
							}else{
								NEJson['Volume']='';
							}
							NEJson['Issue'] = (shitInfo.match(regex1))?shitInfo.split('(')[1].split(')')[0]:'';
							NEJson['Pages'] = (shitInfo.split(';')[shitInfo.split(';').length-1].match('-') || !(shitInfo.split(';')[shitInfo.split(';').length-1].match(regex1)))?shitInfo.split(';')[shitInfo.split(';').length-1]:'';
						break;
						case 'ISSN':
							NEJson['ISBN/ISSN'] = jQuery.trim(rowArr[1]);
						break;
						case '关键词':
							var re = new RegExp(';','g');
							NEJson['Keywords'] = jQuery.trim(rowArr[1]).replace(re,'; ');
						break;
						case '摘要':
							NEJson['Abstract'] = jQuery.trim(rowArr[1]);
						break;
					}
				}
			break;

		}
		console.log(NEJson);
		sendJsonArr.push(NEJson);
		return sendJsonArr;
	}
	// 隐藏下载全文DOM
	jQuery('.operateRowBlock_pNE').html('');
	// 显示加载页
	showLoading();
	var checkDom = setInterval(function(){
		if(jQuery('#gettingContentBlock_pNE').is(':visible')){
			clearInterval(checkDom);
			var pureJson = '';
			pureJson = detailDataToJson();
			ParserDetailsJson(pureJson);
		}
	},300);
})();