(function(){
    function rep_values(doctype){
        var exoprt_id='';
        switch (doctype){
            case "perio":
                exoprt_id="periodical_";
                break;
            case "degree":
                exoprt_id="thesis_";    
                break;
            case "conference":
                exoprt_id="conference_";    
                break;
            case "standards":
                exoprt_id="standard_";  
                break;
            case "patent":
                exoprt_id="patent_";    
                break;
            case "tech":
                exoprt_id="nstr_";  
                break;
            case "techResult":
                exoprt_id="cstad_"; 
            case "legislations":
                //exoprt_id="claw_";  
                exoprt_id="";
                break;
        }   
        return exoprt_id;
    }

    function protoToNE(raws) {
        function findTitle(e) {
            if (e) {
                for (var t = "", r = 0; r < e.length; r++)
                    if (e[r]) {
                        t = e[r];
                        break
                    }
                return t
            }
            return ""
        }
        function appendKeyWord(txt, un, e) {
            if (e) {
                for (var t = "", r = 0; r < e.length; r++)
                    if (e[r]) {
                        txt = txt + '\n\r' + un +  e[r];
                }
            }
            return txt
        }

        function addstr(txt, str){
            if(str !== undefined || str !== ''){
                const content = str.split(':').slice(1).join(':').trim();
                if (content === undefined || content === '' || content === 'undefined') {
                    return txt;
                }
                if(txt == ''){
                    txt = str
                }else{
                    txt = txt + '\n\r' + str.replace(/[\n\r]/g, '')
                }
            }
            return txt;
        }

        contents = []
        for (var rawline = 0; rawline < raws.resourcesList.length; rawline++){
            var rawdict = raws.resourcesList[rawline];
            console.log(rawdict);
            content = '';
            if(rawdict.periodical !== undefined){
                raw = rawdict.periodical;
                content = addstr(content, "{Reference Type}: Journal Article");
                content = addstr(content, "{Title}: " + findTitle(raw.titleList));
                if(raw.titleList[1] !== '' && raw.titleList[1] !== undefined){;
                    content = addstr(content, "{Translated Title}: " + raw.titleList[1]);
                }else if(raw.periodicaltitleList[1] !== '' && raw.periodicaltitleList[1] !== undefined){
                    content = addstr(content, "{Translated Title}: " + raw.periodicaltitleList[1]);
                }
                content = appendKeyWord(content, "{Author}: ", raw.creatorList);
                content = appendKeyWord(content, "{Translated Author}: ", raw.foreigncreatorList);
                content = appendKeyWord(content, "{Author Address}: ", raw.organizationnormList);
                if(raw.periodicaltitleList !== ''){
                    content = addstr(content, "{Journal}: " + findTitle(raw.periodicaltitleList));
                }
                if(raw.issn !== ''){
                    content = addstr(content, "{ISSN}: " + raw.issn);
                }
                if(raw.volum !== ''){
                    content = addstr(content, "{Volume}: " + raw.volum);
                }
                if(raw.publishyear !== ''){
                    content = addstr(content, "{Year}: " + raw.publishyear);
                }
                if(raw.publishdate !== ''){
                    content = addstr(content, "{Date}: " + raw.publishdate.replace(' 00:00:00', ''));
                }
                if(raw.issue !== ''){
                    content = addstr(content, "{Issue}: " + raw.issue);
                }
                if(raw.page !== ''){
                    content = addstr(content, "{Pages}: " + raw.page);
                }
                content = appendKeyWord(content, "{Keywords}: ", raw.keywordsList);
                if(findTitle(raw.abstractList) !== ''){
                    content = addstr(content, "{Abstract}: " + findTitle(raw.abstractList));
                }
                content = addstr(content, "{DOI}: " + raw.doi);
                content = addstr(content, "{Language}: " + raw.language);
                content = appendKeyWord(content, "{Funding}: ", raw.fundList);

            }else if(rawdict.thesis !== undefined){
                raw = rawdict.thesis;
                content = addstr(content, "{Reference Type}: Thesis");
                content = addstr(content, "{Title}: " + findTitle(raw.titleList));
                if(raw.titleList[1] !== ''){;
                    content = addstr(content, "{Translated Title}: " + raw.titleList[1]);
                }
                content = appendKeyWord(content, "{Author}: ", raw.creatorList);
                content = appendKeyWord(content, "{Tertiary Author}: ", raw.tutorList);
                content = appendKeyWord(content, "{Author Address}: ", raw.organizationnormList);
                if(raw.originalorganizationList !== ''){
                    content = addstr(content, "{Publisher}: " + findTitle(raw.originalorganizationList));
                }
                if(raw.major !== ''){
                    content = addstr(content, "{Section}: " + raw.major);
                }
                if(raw.degree !== ''){
                    content = addstr(content, "{Type of Work}: " + raw.degree);
                }
                if(raw.publishyear !== ''){
                    content = addstr(content, "{Year}: " + raw.publishyear);
                }
                if(raw.publishdate !== ''){
                    content = addstr(content, "{Date}: " + raw.publishdate.replace(' 00:00:00', ''));
                }
                content = appendKeyWord(content, "{Keywords}: ", raw.keywordsList);
                if(findTitle(raw.abstractList) !== ''){
                    content = addstr(content, "{Abstract}: " + findTitle(raw.abstractList));
                }
                content = addstr(content, "{DOI}: " + raw.doi);
                content = addstr(content, "{Language}: " + raw.language);
                content = appendKeyWord(content, "{Funding}: ", raw.fundList);

            }else if(rawdict.conference !== undefined){
                raw = rawdict.conference;
                content = addstr(content, "{Reference Type}: Conference Proceedings");
                content = addstr(content, "{Title}: " + findTitle(raw.titleList));
                if(raw.titleList[1] !== ''){;
                    content = addstr(content, "{Translated Title}: " + raw.titleList[1]);
                }
                content = addstr(content, "{Tertiary Title}: " + raw.meetingcorpus);
                content = appendKeyWord(content, "{Author}: ", raw.creatorList);
                content = appendKeyWord(content, "{Tertiary Author}: ", raw.tutorList);
                content = appendKeyWord(content, "{Author Address}: ", raw.organizationnormList);
                content = addstr(content, "{Secondary Title}: "+ findTitle(raw.meetingtitleList));
                if(raw.meetingarea !== ''){
                    content = addstr(content, "{Place Published}: " + findTitle(raw.meetingarea));
                }
                if(raw.originalorganizationList !== ''){
                    content = addstr(content, "{Publisher}: " + findTitle(raw.originalorganizationList));
                }
                content = appendKeyWord(content,"{Subsidiary Author}: ", raw.major);
                if(raw.page !== ''){
                    content = addstr(content, "{Pages}: " + raw.page);
                }
                if(raw.publishyear !== ''){
                    content = addstr(content, "{Year}: " + raw.publishyear);
                }
                if(raw.publishdate !== ''){
                    content = addstr(content, "{Date}: " + raw.publishdate.replace(' 00:00:00', ''));
                }
                content = appendKeyWord(content, "{Keywords}: ", raw.keywordsList);
                if(findTitle(raw.abstractList) !== ''){
                    content = addstr(content, "{Abstract}: " + findTitle(raw.abstractList));
                }
                content = addstr(content, "{DOI}: " + raw.doi);
                content = addstr(content, "{Language}: " + raw.language);
                content = appendKeyWord(content, "{Funding}: ", raw.fundList);

            }else if(rawdict.patent !== undefined){
                raw = rawdict.patent;
                content = addstr(content, "{Reference Type}: Patent");
                content = addstr(content, "{Title}: " + findTitle(raw.titleList));
                content = appendKeyWord(content, "{Author}: ", raw.inventorList);
                content = appendKeyWord(content, "{Applicant Name}: ", raw.applicantList);
                content = appendKeyWord(content, 'Subsidiary Author', raw.applicantList);
                content = addstr(content, "{Author Address}: " + raw.applicantaddress);
                if(raw.patentcode !== ''){
                    content = addstr(content, "{Application Number}: " + raw.patentcode);
                    content = addstr(content, "{Issue}: " + raw.patentcode);
                }
                if(raw.publicationno !== ''){
                    content = addstr(content, "{Volume}: " + raw.publicationno);
                    content = addstr(content, "{Number}: " + raw.publicationno);
                }
                if(raw.publicationdate !== ''){
                    content = addstr(content, "{Subject Headings}: " + raw.publicationdate);
                }
                if(raw.countryorganization !== ''){
                    content = addstr(content, "{Country}: " + raw.countryorganization);
                }
                if(raw.patenttype !== ''){
                    content = addstr(content, "{Type of Work}: " + raw.patenttype);
                }
                if(raw.signoryitem !== ''){
                    content = addstr(content, "{Subject}: " + raw.signoryitem);
                }
                if(raw.publishyear !== ''){
                    content = addstr(content, "{Year}: " + raw.publishyear);
                }
                if(raw.publishdate !== ''){
                    content = addstr(content, "{Reviewed Item}: " + raw.publishdate.replace(' 00:00:00', ''));
                }
                if(raw.page !== ''){
                    content = addstr(content, "{Pages}: " + raw.page);
                }
                content = appendKeyWord(content, "{Keywords}: ", raw.keywordsList);
                if(findTitle(raw.abstractList) !== ''){
                    content = addstr(content, "{Abstract}: " + findTitle(raw.abstractList));
                }
                content = addstr(content, "{Language}: " + raw.language);
                content = appendKeyWord(content, "{Funding}: ", raw.fundList);

            }else if (rawdict.standard != undefined) {
                raw = rawdict.standard;
                content = addstr(content, "{Reference Type}: Standard");
                content = addstr(content, "{Title}: " + findTitle(raw.titleList));
                if(raw.titleList[1] !== ''){;
                    content = addstr(content, "{Translated Title}: " + raw.titleList[1]);
                }
                content = appendKeyWord(content, "{Keywords}: ", raw.keywordsList);
                content = addstr(content, "{Abstract}: " + findTitle(raw.abstractList));
                content = addstr(content, "{Year}: " + raw.publishyear);
                content = addstr(content, "{ISBN}: " + raw.id);
            }else{

                if(rawdict.book !== undefined){raw = rawdict.book;}
                else if(rawdict.claw !== undefined){raw = rawdict.claw;}
                else if(rawdict.cstad !== undefined){raw = rawdict.cstad;}
                else if(rawdict.localchronicle !== undefined){raw = rawdict.localchronicle;}
                else if(rawdict.magazine !== undefined){raw = rawdict.magazine;}
                else if(rawdict.meeting !== undefined){raw = rawdict.meeting;}
                else if(rawdict.nstr !== undefined){raw = rawdict.nstr;}
                else if(rawdict.patent !== undefined){raw = rawdict.patent;}
                else if(rawdict.standard !== undefined){raw = rawdict.standard;}
                else if(rawdict.standard !== undefined){raw = rawdict.thesiscatalog;}
                // raw = rawdict[rawdict.type.toLowerCase()];
                console.log(raw)
                content = addstr(content, "{Reference Type}: Generic");
                content = addstr(content, "{Title}: " + findTitle(raw.titleList));
                if(raw.titleList[1] !== ''){;
                    content = addstr(content, "{Translated Title}: " + raw.titleList[1]);
                }
                content = appendKeyWord(content, "{Author}: ", raw.creatorList);
                content = appendKeyWord(content, "{Translated Author}: ", raw.foreigncreatorList);
                content = appendKeyWord(content, "{Author Address}: ", raw.organizationnormList);
                if(raw.periodicaltitleList != undefined && raw.periodicaltitleList !== ''){
                    content = addstr(content, "{Journal}: " + findTitle(raw.periodicaltitleList));
                }
                if(raw.issn != undefined && raw.issn !== ''){
                    content = addstr(content, "{ISSN}: " + raw.issn);
                }
                if(raw.volum != undefined && raw.volum !== ''){
                    content = addstr(content, "{Volume}: " + raw.volum);
                }
                if(raw.publishyear != undefined  && raw.publishyear !== ''){
                    content = addstr(content, "{Year}: " + raw.publishyear);
                }
                if(raw.publishdate != undefined  && raw.publishdate !== ''){
                    content = addstr(content, "{Date}: " + raw.publishdate.replace(' 00:00:00', ''));
                }
                if(raw.issue != undefined  && raw.issue !== ''){
                    content = addstr(content, "{Issue}: " + raw.issue);
                }
                if(raw.page != undefined  && raw.page !== ''){
                    content = addstr(content, "{Pages}: " + raw.page);
                }
                content = appendKeyWord(content, "{Keywords}: ", raw.keywordsList);
                if(raw.abstractList != undefined  && findTitle(raw.abstractList) !== ''){
                    content = addstr(content, "{Abstract}: " + findTitle(raw.abstractList));
                }
                content = addstr(content, "{DOI}: " + raw.doi);
                content = addstr(content, "{Language}: " + raw.language);
                content = appendKeyWord(content, "{Funding}: ", raw.fundList);
            }
            if(content !== '' && raw !== undefined){
                content = addstr(content, "{URL}: " + 'https://d.wanfangdata.com.cn/' + raw.type.toLowerCase() + "/" + rawdict.uid);
                content = addstr(content, "{Database Provider}: 北京万方数据股份有限公司");
            }
            
            contents.push(toNEParser(content))
        }
        console.log(contents)
        return contents
    }

    downloadURL = jQuery('.download.buttonItem').attr('href')
    function getID(){
        console.log(downloadURL)
        if (downloadURL != undefined) {
           var regexp = /download\/(.*?)\.aspx/;
            var id = regexp.exec(downloadURL)[1];
            console.log(id);
            if(id !== undefined && id !== ''){
                var type = id.split('_')[0];
                if (rep_values(type) == ''){
                    return ''
                }
                return rep_values(type) + id.split('_')[1]
            } 
        }else{
            if(window.location.href.indexOf('standard') != -1){
                id = $('.standardId').find('.itemUrl').eq(0).text().trim();
                return 'standard_'+id;
            }else {
                
                return ''; 
            }
            
        }
        
    }


    function transRequestParam(req) {
        let tData = new Uint8Array(5 + req.length)
        // 0,0,0,0,长度,proto2进制包
        //前5位其实是代表长度,不满5位就补0
        let pos5 = req.length
        let pos4 = Math.floor(req.length/256)

        if(req.length > 255){
          pos5 = req.length - 256
        }
        tData.set(new Uint8Array([0, 0, 0, pos4, pos5]), 0)
        console.log(tData)
        tData.set(req, 5)
        console.log('trans====',req.length,tData)
        return tData
    }
    function buf2hex(buffer) {
        return Array.prototype.map.call(new Uint8Array(buffer), x => ('00' + x.toString(16)).slice(-2)).join('');
    }

    function getContentData(){
        var postdata= getID()

        console.log('postdata', postdata)

        if(postdata !== '' && postdata !== undefined){
            console.log('postdata', postdata)
            var ExportRequest = new proto.WwwService.ExportRequest()
            ExportRequest.setExportItem(postdata)
            ExportRequest.serializeBinary()
            var postdata = transRequestParam(ExportRequest.serializeBinary())
            var xhr = new XMLHttpRequest()
            xhr.open('post', '/WwwService.ExportService/export', true)
            xhr.responseType = 'arraybuffer'
            xhr.setRequestHeader("Content-Type","application/grpc-web+proto")
            xhr.setRequestHeader("Cookies", "CASTGC=" + getCookie("CASTGC") + ";CASTGCSpecial=" + getCookie("CASTGCSpecial") + ";")
            xhr.onload = function(e) {
                if (this.status == 200) {
                    console.log(xhr.response)
                    var length = parseInt(buf2hex(xhr.response.slice(0, 5)), 16)
                    var obj = proto.WwwService.ExportResponse.deserializeBinary(xhr.response.slice(5, 5 + length))
                    console.log(obj.toObject())
                    console.log(obj);
                    ParserDetailsJson(protoToNE(obj.toObject()))
                 }
            };
            xhr.send(postdata)
        }else {

            var data_Json = {};
            if(window.location.href.indexOf('nstr') != -1){
                data_Json['Reference Type'] = 'Report';
            }else if(window.location.href.indexOf('periodical') != -1 ){
                data_Json['Reference Type'] = 'Journal Article';
            }else if(window.location.href.indexOf('conference') != -1 ){
                data_Json['Reference Type'] = 'Conference Proceedings';
            } else {
                data_Json['Reference Type'] = 'Generic';
            }
            
            // 取得$('.detailTitleCN')下第一个div的第一个span的文本内容，即为标题
            var title = $('.detailTitleCN > div:first-child > span:first-child').text();
            if (title === '') {
                title = $('.detailTitleCN > span:first-child').text().trim();
            }
            data_Json['Title'] = title;

            var list = $('.keyword.list').find('a');
            var keywordList = [];
            for(var i =0;i<list.length;i++){
                var keyword = list.eq(i).text();
                keywordList.push(keyword);
            }
            var keywords = keywordList.join(';');
            data_Json['Keywords'] = keywords;

            if ($('.meetingDate.list')){
                data_Json['Date'] = $('.meetingDate.list').find('.itemUrl').text().trim();
                console.log(data_Json['Date'])
            }

            if ($('.meetingArea.list')){
                data_Json['Place Published'] = $('.meetingArea.list').find('.itemUrl').text().trim();
                console.log(data_Json['Place Published'])
            }
 
            if ($('.mettingName.list')){
                data_Json['Secondary Title'] = $('.mettingName.list').find('a').text().trim();
                console.log(data_Json['Secondary Title'])
            }
            if ($('.sponsor.list')){
                data_Json['Publisher'] = $('.sponsor.list').find('a').text().trim();
                console.log(data_Json['Publisher'])
            }
 
            if ($('.pageNum.list')){
                data_Json['Pages'] = $('.pageNum.list').find('.itemUrl').text().trim();
                console.log(data_Json['Pages'])
            }
            if ($('.classify.list')){
                data_Json['Category'] = $('.classify.list').find('.itemUrl').text().trim();
                console.log(data_Json['Category'])
            }
 

            var abstract = $('.summary').text().replace('摘要：','').replaceAll('\n','').trim();
            data_Json['Abstract'] = abstract;

            var list2 = $('.author.detailTitle').find('a');
            var authorList = [];
            for(var i=0;i<list2.length;i++){
                var author = $(list2.eq(i)).clone()
                // 移除所有层级的sup元素（包括嵌套的）
                .find('sup').remove().end() 
                
                // 移除所有空白文本节点（包括换行和空格）
                .contents().filter(function() {
                    return this.nodeType === 3 && /^\s*$/.test(this.nodeValue);
                }).remove().end()
                
                // 提取纯文本并去除首尾空格
                .text().trim();
            
                authorList.push(author);
            }




            var authors = authorList.join(';');
            data_Json['Author'] = authors;
            data_Json['Database Provider'] = '北京万方数据股份有限公司';
            data_Json['URL'] = window.location.href;
           
            var postData = [data_Json];
            
            ParserDetailsJson(postData);
            

        }
    }


    // 显示加载页
    showLoading();
    var checkDom = setInterval(function(){
        if(jQuery('#gettingContentBlock_pNE').is(':visible')){
            clearInterval(checkDom);
            getContentData();
            if(jQuery('.download.buttonItem').length != 0){
            }else{jQuery('.operateRowBlock_pNE').html('');}
            jQuery('#saveBlock_pNE').bind('click',function(){
                if(jQuery('.downloadFullEle_pNE[name="downloadFull_pNE"]').is(':checked')){
                    if(jQuery('.download.buttonItem').length != 0){
                        jQuery('.download.buttonItem')[0].click();
                    }
                }
            });
            // jQuery('.operateRowBlock_pNE').html('')
        }
    },300);
    // getContentData();
    // if(jQuery('[title="下载"]').length != 0){
    // }else{jQuery('.operateRowBlock_pNE').html('');}
    // jQuery('#saveBlock_pNE').bind('click',function(){
    //  if(jQuery('.downloadFullEle_pNE[name="downloadFull_pNE"]').is(':checked')){
    //      if(jQuery('[title="下载"]').length != 0){
    //          jQuery('[title="下载"]')[0].click();
    //      }
    //  }
    // })

})();