(function(){
	String.prototype.trim = function (char, type) {
	  	if (char) {
		    if (type == 'left') {
		      return this.replace(new RegExp('^\\'+char+'+', 'g'), '');
		    } else if (type == 'right') {
		      return this.replace(new RegExp('\\'+char+'+$', 'g'), '');
		    }
		    return this.replace(new RegExp('^\\'+char+'+|\\'+char+'+$', 'g'), '');
		}
		return this.replace(/^\s+|\s+$/g, '');
	};

	function ne_parse_xml_json(xml_json) {
		var ref = {};
		function has_key(ref,keyname,values){
			if(values != undefined && values != ""){
				return ref[keyname] = values;
			}
		}

		var type = jQuery(xml_json).find("Type").text();
		if(type != undefined && type != ""){
			if(type == "1"){
				ref["Reference Type"] = "Journal Article";
			}else{
				ref["Reference Type"] = "Generic";
			}
		}

		var urlid = jQuery(xml_json).find("ID").text();
		if(urlid != undefined && urlid != ""){
			ref["URL"] = "http://qikan.cqvip.com/Qikan/Article/Detail?id=" + urlid;
		}		

		var nameDom = jQuery(xml_json).find("Creators").find("Creator");
		if(nameDom.length != 0){
			var Author = "";
			for (var i = 0; i < nameDom.length; i++) {
				Author =Author + jQuery(nameDom[i]).find("Name").text().trim(',').trim('.') + ";" ;
			}
			ref["Author"] = Author.trim(';');

		}

		var affiliationDom = jQuery(xml_json).find("Organs").find("Organ");
		if(affiliationDom.length != 0){
			var affiliation = "";
			for (var i = 0; i < affiliationDom.length; i++) {
				affiliation = jQuery(affiliationDom[i]).text() + ";" + affiliation;
			}
			ref["Author Affiliation"] = affiliation.trim(';');
		}

		var codeDom = jQuery(xml_json).find("CLC");
		if(codeDom.length != 0){
			ref["Category"] = "";
			for (var i = 0; i < codeDom.length; i++) {
				ref["Category"] = jQuery(codeDom[i]).find("Code").text() + ";" + ref["Category"];
			}
			ref["Category"].trim(';');
		}

		var KeywordDom = jQuery(xml_json).find("Keywords").find("Keyword");
		if(KeywordDom.length != 0){
			var Keywords = "";
			for (var i = 0; i < KeywordDom.length; i++) {
				Keywords = jQuery(KeywordDom[i]).text() + ";" + Keywords;
			}
			ref["Keywords"] = Keywords.trim(";");
		}

		has_key(ref,"Title",jQuery(xml_json).find("Titles").find("Title").find("Text").text());
		has_key(ref,"Abstract",jQuery(xml_json).find("Abstracts").find("Abstract").find("Text").text());
		has_key(ref,"Journal",jQuery(xml_json).find("Periodical").find("Name").text());
		has_key(ref,"ISBN/ISSN",jQuery(xml_json).find("Periodical").find("ISSN").text());
		has_key(ref,"Volume",jQuery(xml_json).find("Volum").text());
		has_key(ref,"Issue",jQuery(xml_json).find("Issue").text());
		has_key(ref,"Pages",jQuery(xml_json).find("Page").text());
		has_key(ref,"Year",jQuery(xml_json).find("PublishDate").text().substr(0,4));

		return ref;

	}

	function getListContentData(postdata){
		if(postdata != ""){
			var url = "/Qikan/Search/Export?from=Qikan_Search_Index";
			var data = http_Post(url, {"strType":'title_info',"ids":postdata});	
			var el = document.createElement( 'html' );
			el.innerHTML = data;
			var resultPageDom = jQuery(el).find("#xmlContent").attr("value");
			var parser=new DOMParser(); 
			var XMLdoc=parser.parseFromString(resultPageDom,"text/xml");
			var domElems=XMLdoc.getElementsByTagName("PeriodicalPaper");
			Contents = [];
			for (var i = 0; i < domElems.length; i++) {
				NEXML = domElems[i];
				Contents.push(ne_parse_xml_json(NEXML));
			}
			return Contents;
		}
	}



	function getResId(){
		var postdata = "";
		// var baseObj = jQuery('.search-result-list');
		if (jQuery(".tab-this").length!=0){
			var baseObj = jQuery(`div.row.search-list[data-guid="${jQuery(".tab-this").attr("data-guid")}"]`).find('.simple-list dl')
		}else{
			var baseObj = jQuery('.search-result-list  .simple-list dl')
		}


		if(baseObj.length != 0){
			jQuery(baseObj).each(function(idx, val) {
				var risId = jQuery(this).find("dt").find("a").attr("articleid");
				if(risId != undefined && risId !=""){
					if(postdata != ""){
						postdata = postdata + "," + risId;
					}else{
						postdata = risId;
					}
				}
			})
		}
		return getListContentData(postdata);
	}


    // 绘制插件对话框内容功能
    function rebuildContent(){
        // 显示加载页
        showLoading();
        var checkDom = setInterval(function(){
            if(jQuery('#gettingContentBlock_pNE').is(':visible')){
                clearInterval(checkDom);
                var pureJson = '';
                pureJson = getResId();
                ParserJson(pureJson);
            }
        },300);
    }
    // 首次加载时插件对话框内容绘制
    rebuildContent();
    // 绑定刷新按钮事件方法
    clickRefreshFun(rebuildContent);


})();