(function(){

	function getRISDataList(RISData){
		var RISDataList = [];
		var tmpRISDataList = RISData.split('ER  -');
		for(var i = 0; i < tmpRISDataList.length; i++){
			var data = tmpRISDataList[i].trim();
			if('' != data){
				var ris = getContent(data);
				if(ris['DOI'] !== undefined && ris['DOI'] !== ""){
					ris['URL'] = "https://doi.org/" + ris['DOI'];
				}
				RISDataList.push(ris);
			}
		}
		return RISDataList;
	}

	function getListContentData(postdata){
		if(postdata != ""){
			var url = `/rest/search/citation/format?recordIds=${postdata}&download-format=download-ris`
			var r = http_get(url);
			var risRaw = JSON.parse(r)['data'];
			var rislist = getRISDataList(risRaw);
			return rislist;
		}
	}


	function getResId(){
		try {
			var postdata = "";
			var dom =  jQuery("xpl-results-list");
			if(dom.length > 0){
				jQuery("xpl-results-list").find(".result-item-title").find("a").each(function(){
					if(postdata == ""){
						postdata = jQuery(this).attr("href").replace(/[A-Za-z0-9]+/,"").replace(/[/]/g,"");
					}else{
						postdata = postdata + "," + jQuery(this).attr("href").replace(/[A-Za-z0-9]+/,"").replace(/[/]/g,"");
					}
					
					
				})
				return getListContentData(postdata);
			}
		} catch (error) {
		  console.error(error);
		  return [];
		}
		
	}

	function rebuildContent(){
        // 显示加载页
        showLoading();
        var checkDom = setInterval(function(){
            if(jQuery('#gettingContentBlock_pNE').is(':visible')){
                clearInterval(checkDom);
                var pureJson = '';
                pureJson = getResId();
                ParserJson(pureJson);
            }
        },300);
    }
    // 首次加载时插件对话框内容绘制
    rebuildContent();
    // 绑定刷新按钮事件方法
    clickRefreshFun(rebuildContent);
	
})();