(function () {



    function csvToObjects(csv) {
        const lines = csv.trim().split('\n');
        const headers = lines.shift().split(',');
        const result = [];
        lines.forEach(line => {
            const values = line.split(',');
            const obj = {};
            headers.forEach((header, index) => {
                console.log(header);
                console.log(index);
                obj[header] = values[index];
            });
            result.push(obj);
        });
        return result;
    }

    function processArray(values) {
        for (let index = 11; index < values.length; index++) {
            if (values[10] !== '') {
                if (values[index] !== undefined && values[index] !== '' && !/^\d+$/.test(values[index])) {
                    values[10] += values[index];
                    values.splice(index, 1);
                    index--;
                } else {
                    return values;
                }   
            }
        }
        return values;
    }

    function getQueryParam(url, paramName) {
        const urlObj = new URL(url);
        const params = new URLSearchParams(urlObj.search);
        return params.get(paramName);
    }

    function checkTextInDocument(text) {
        // 这里为了简化，我们只检查<body>标签的文本内容
        // 注意：这不会捕获所有元素内的文本，因为innerText/textContent不会跨元素合并文本
        const bodyText = document.body.innerText || document.body.textContent; // 兼容性处理
        return bodyText.includes(text);
    }

    function getResId() {
        var postdata = [];

        var inputs = document.querySelectorAll('input.selectOne');

        // 遍历这些 <input> 标签
        inputs.forEach(function(input) {
            // 获取 value 属性
            var value = input.value;
            console.log('Value:', value);
            var url = 'https://www.lens.org/lens/export/patent/' + value + '/citation?format=ris&filename=';
           setTimeout(function(){}, 1000);
            
            const ris = http_get(url);
            console.log(ris);

            var data = getContent(ris);

            data['Database Provider'] = 'lens';

            postdata.push(data);

        });
        return postdata;

        
    }    

    function getResId_bak() {
        var postdata = [];
        
        var total = jQuery('.query-details').find('.query-details-count').text();

        total = total.trim();
        total = total.replace('(', '');
        total = total.replace(',', '');
        total = total.replace(')', '');
        
        console.log(total);

        if (total !== 0) {
            //获取id，分别获取每个id的详细信息
            var results = jQuery('section').find('main').find('#resultsTable').find('.div-table-results-body');
            results.find('.div-table-results-row').each(function() {
                var itemText = $(this).find('.header-meta-inline-item a span').text();
                console.log(itemText);
                var url = 'https://www.lens.org/lens/api/scholarly/' + itemText + '/citation?format=csv&filename=lens-citation';
                const data = http_get(url);
                const lines = data.trim().split('\n');
                if (lines.length > 1) {
                    const line = lines[1];
                    var values = line.split(',');
                    values = processArray(values);
                    const data_Json = {};
        
                    console.log('find it!');
                    data_Json['Reference Type'] = 'Generic';
                    if (values[4] === "journal article") {
                        data_Json['Reference Type'] = 'Journal Article';
                    } else if (values[4] === "book") {
                        data_Json['Reference Type'] = 'Book';
                    }  else if (values[4] === "conference proceedings article") {
                        data_Json['Reference Type'] = 'Conference Proceedings';
                    }  else if (values[4] === "report") {
                        data_Json['Reference Type'] = 'Report';
                    }  else if (values[4] === "dataset") {
                        data_Json['Reference Type'] = 'Book';
                    }
                    data_Json['Title'] = values[1];
                    data_Json['Author'] = values[9];
                    data_Json['URL'] = 'https://www.lens.org/lens/scholar/article/' + values[0] + '/main';
                    data_Json['Keywords'] = values[16];
                    data_Json['Abstract'] = values[10];
                    data_Json['Year'] = values[3];
                    data_Json['Journal'] = values[5];
                    data_Json['Volume'] = values[11];
                    data_Json['Pages'] = values[13] + '-' + values[14];
                    data_Json['ISBN/ISSN'] = values[6];
                    data_Json['Issue'] = values[12];
                    data_Json['DOI'] = values[23];
                    postdata.push(data_Json);
        
                };
            });

            return  postdata;
        }
    }


    // 绘制插件对话框内容功能
    function rebuildContent(){
        // 显示加载页

        showLoading();
        var checkDom = setInterval(function(){
            if(jQuery('#gettingContentBlock_pNE').is(':visible')){
                clearInterval(checkDom);
                var pureJson = '';
 
                pureJson = getResId();
                return ParserJson(pureJson);
                //return getResId();
                
            }
        },300);
    }
    // 首次加载时插件对话框内容绘制

    //将pluginDialogOfNE 下所有input的display改为显示
    // 假设 pluginDialogOfNE 是一个类名或ID
    //jQuery('#pluginDialogOfNE input').css('display', 'block');
    console.log('lens list load');
    rebuildContent();
    // 绑定刷新按钮事件方法
    clickRefreshFun(rebuildContent);

})()