(function(){
    function parseJournal(NE, Journal) {
        // 正则表达式调整以匹配不同格式
        const regex = /《([^》]+)》\s+(\d+)年(?:(\d+)月)?(?:第(\d+)期)?(?:(\d+)-(\d+))?,共(\d+)页/;
        const match = Journal.match(regex);
        if (match) {
            NE.Journal = match[1]; // 期刊标题
            NE.Year = match[2]; // 年份
            //NE.month = match[3] || ''; // 月份（数字，无"月"字）
            NE.Issue = match[4] || ''; // 期数（数字，无"第"和"期"）
            NE.startPage = match[5] || ''; // 起始页码
            NE.endPage = match[6] || ''; // 结束页码
            NE.Pages = NE.startPage + '-' + NE.endPage; // 完整页码范围
            console.log(NE);

            NE.totalPages = match[7]; // 总页数
        } else {
            console.error('无法解析期刊信息:', Journal); // 修复变量名大小写
        }
    }
    //转到详情页
    function gethref(obj, NE) {
        var id = $(obj).attr("data-id");
        var type = $(obj).attr("data-name");
        var datatype = $(obj).attr("data-type");
        var typename = $(obj).attr("data-type");
        var synUpdateType = $(obj).attr("data-synUpdateType");
        var barcodenum = "";

        NE['Reference Type'] = 'Journal Article';
        if (datatype == "中文期刊文章") {
            datatype = "journalArticle";
        }
        if (datatype == "集刊文章") {
            datatype = "collectionsArticle";
        }
        if (datatype == "外文期刊文章") {
            datatype = "eJournalArticle";
        }
        if (datatype == "古籍") {
            barcodenum = $(obj).attr("data-barcodenum");
            datatype = "Ancient";
            NE['Reference Type'] = 'BOOK';
        }
        if (datatype == "外文图书") {
            barcodenum = $(obj).attr("data-id");
            datatype = "Book";
            NE['Reference Type'] = 'BOOK';
        }
        if (datatype == "方志") {
            datatype = "LocalRecords";
        }
        if (datatype == "会议论文") {
            datatype = "Conference";
            NE['Reference Type'] = 'Conference Proceedings';
        }
        if (datatype == "学位论文") {
            datatype = "Degree";
            NE['Reference Type'] = 'Thesis';
        }
        if (AntiSqlValid(id) == true && AntiSqlValid(type) == true && AntiSqlValid(datatype) == true && AntiSqlValid(typename) == true && AntiSqlValid(barcodenum) == true) {
            // window.open("/Literature/articleinfo?id=" + $.base64.encode(id, 'utf8') + "&type=" + $.base64.encode(datatype, 'utf8') + "&datatype=" + $.base64.encode(type, 'utf8') + "&typename=" + $.base64.encode(typename, 'utf8') + "&nav=" + nav + "&barcodenum=" + $.base64.encode(barcodenum, 'utf8'));
            return "https://www.ncpssd.cn" + encodeURI("/Literature/articleinfo?id=" + id + "&type=" + datatype + "&datatype=" + type + "&typename=" + typename + "&synUpdateType=" + synUpdateType + "&nav=" + nav + "&barcodenum=" + barcodenum + "&pageUrl=" + encodeURIComponent(window.location.href))
        }
    }

    function getResId(){

        var arr = [];
        var url = window.location.toString();

        const ul = document.getElementById('ul_articlelist');
        const lis = ul.getElementsByTagName('li');
        for (let i = 0; i < lis.length; i++) {
            NE = {};

            const firstA = lis[i].querySelector('li a');
            NE['Title'] = firstA.textContent;
            NE['URL'] = gethref(firstA , NE);

            const ps = lis[i].getElementsByTagName('p');
            for (let j = 0; j < ps.length; j++) {
                const strong = ps[j].querySelector('strong');
                if (!strong){
                    console.log('没有 strong 标签');
                    continue;
                }
                switch (strong.textContent) {
                    case '出　　处':
                        var Journal = ps[j].querySelector('a').textContent;
                        parseJournal(NE, Journal);
                        break;
                    case '作　　者':
                        const authors = ps[j].getElementsByTagName('font');
                        NE.Author = Array.from(authors).map(a => a.textContent.trim()).join('; ');    
                        break; 
                    case '摘　　要':
                        NE['Abstract'] = ps[j].textContent;
                        NE['Abstract'] = NE['Abstract'].replace('摘　　要：', '');
                        break;
                    case '关 键 词':
                        NE['Keywords'] = '';
                        var fonts = ps[j].getElementsByTagName('font');
                        for (var k = 0; k < fonts.length; k++) {
                            if (k > 0) NE['Keywords'] += ';';
                            NE['Keywords'] += fonts[k].textContent;
                        }
                        //NE['Keywords'] = NE['Keywords'].replace('关 键 词：', '').replace(' ', ';');


                        break;       
                }
            }
            arr.push(NE);
        }
        return arr;    
    }
	
 
    // 绘制插件对话框内容功能
    function rebuildContent(){
        // 显示加载页
        showLoading();
        var checkDom = setInterval(function(){
            var labelElement = document.querySelector('#lbl_numbers');
            if (labelElement) {
                var numberValue = labelElement.textContent;
                var number = Number(numberValue);
                if(number > 0) {
                    clearInterval(checkDom);
                    data = getResId();
                    ParserJson(data);
                }
            }
        },300);
    }
    // 首次加载时插件对话框内容绘制
    rebuildContent();
    // 绑定刷新按钮事件方法
    clickRefreshFun(rebuildContent);

	})();