(function () {
    // 绘制插件对话框内容功能
    function rebuildContent(){
        // 显示加载页
        showLoading();

        // 获取目标元素
        const pluginDialog = document.getElementById('pluginDialogOfNE');

        // 阻止事件传播的通用函数
        function preventEventPropagation(el, eventNames) {
        eventNames.forEach(eventName => {
            el.addEventListener(eventName, (e) => {
            e.stopPropagation();
            // 如果需要完全阻止指令行为，可以添加：
            e.stopImmediatePropagation();
            }, true); // 使用捕获阶段监听
        });
        }

        // 执行阻止操作
        if (pluginDialog) {
        preventEventPropagation(pluginDialog, ['mousedown', 'click']);
        
        // 可选：递归处理所有子元素
        function traverseAndPrevent(parent) {
            parent.childNodes.forEach(node => {
            if (node.nodeType === Node.ELEMENT_NODE) {
                preventEventPropagation(node, ['mousedown', 'click']);
                traverseAndPrevent(node);
            }
            });
        }
        traverseAndPrevent(pluginDialog);
        }


       //添加这段css #pluginDialogOfNE { pointer-events: none;}
        
        //jQuery('#pluginDialogBlock_pNE').css('pointer-events', 'none');
 
        //jQuery('#saveBlock_pNE').css('pointer-events', 'none');
 


        var checkDom = setInterval(function(){
            if(jQuery('#gettingContentBlock_pNE').is(':visible')){
                clearInterval(checkDom);
                var pureJson = '';
                //jQuery('#pluginDialogBlock_NE')清空这个元素的内容
                //jQuery('#pluginDialogBlock_NE').empty();


                //<div id="pathBlock_pNE" class="pathBlock_pNE"  点击这个元素，但这个元素下层的内容会响应，我希望可以直接点击这个元素，而其他元素不响应
                

                console.log(jQuery('#pluginDialogBlock_NE').html());
                jQuery('#pluginDialogBlock_NE #saveBlockDisable_pNE').remove();
                jQuery('#pluginDialogBlock_NE .operateRowBlock_pNE').remove();
                jQuery('#pluginDialogBlock_NE #contentBlock_pNE').remove();

                

                if(IsDetailPage()){
                    jQuery('#pluginDialogBlock_NE').append(dialogDetailHtmlStr);
                    //jQuery('#pluginDialogBlock_NE').append(avaliableListHTMLStr);
                    getResId_detail();    
                } else {
                    jQuery('#pluginDialogBlock_NE').append(dialogListHtmlStr);
                    console.log(dialogListHtmlStr);
                    //jQuery('#pluginDialogBlock_NE').append(avaliableListHTMLStr);
                    pureJson = getResId();
                    ParserJson(pureJson);
                }

            }
        },300);
    }



    // 首次加载时插件对话框内容绘制
    rebuildContent();
    // 绑定刷新按钮事件方法
    clickRefreshFun(rebuildContent);


    //添加一个函数 IsDetailPage，返回true or flase，如果当前页面url有zoom参数，则为true
    function IsDetailPage() {
        var url = window.location.href;
        if (url.indexOf('zoom=') !== -1) {
            return true;
        } else {
            return false;
        }
    }

    function getResId() {
        //get url
        //https://openalex.org/works?page=1&filter=title_and_abstract.search%3Acar
        //https://api.openalex.org/works?page=1&filter=title_and_abstract.search:car&sort=relevance_score:desc&per_page=10

        var url = window.location.href;
        url = url.replace('https://openalex.org/','https://api.openalex.org/');
        if (url.indexOf('sort=') === -1) {
            url = url + '&sort=relevance_score:desc';
        }
        if (url.indexOf('per_page=') === -1) {
            url = url + '&per_page=10';
        }
        console.log(url);

        //get content
        var content = http_get(url);
        //console.log(content);
        //parse content
        var jsonObj = JSON.parse(content);
        var results = jsonObj.results;
        var postData = [];
        for (var i = 0; i < results.length; i++) {
            var data = {}
            var result = results[i];
            data['Title'] = result.title;
 
            switch (result.type_crossref) {
                case 'journal-article':
                    data['Reference Type'] = 'Journal Article';
                    break;
                default:
                    data['Reference Type'] = 'Generic';
            }
            data['DOI'] = result.doi;
            data['year'] = result.publication_year;
            data['Language'] = result.language;
            data['Author'] = '';
            for (var j = 0; j < result.authorships.length; j++) {
                data['Author'] = data['Author'] + result.authorships[j].author.display_name + ';';
            }
            data['Cite Count'] = result.cited_by_count;

            data['Keywords'] = '';
            for (var j = 0; j < result.keywords.length; j++) {
                data['Keywords'] = data['Keywords'] + result.keywords[j].display_name + ';';
            }
            data['Database Provider'] = 'openalex';
            
            // console.log(data);

            postData.push(data);
        }
        //return data
;
        return postData;
    }


    function getResId_detail() {

        var Urls = jQuery('.v-navigation-drawer__content .v-toolbar__content');
        var anchors = Urls.find('a');
        var url;
        anchors.each(function() {
            if (this.href.includes('https://api.openalex.org/')) {
                url = this.href;
                return false; // 终止循环
            }
        });
        console.log(url);

        var content = http_get(url);

        var jsonObj = JSON.parse(content);
        var result = jsonObj;
        var data = {}
        var postData = [];    
        data['Title'] = result.title;
 
        switch (result.type_crossref) {
            case 'journal-article':
                data['Reference Type'] = 'Journal Article';
                break;
            default:
                data['Reference Type'] = 'Generic';
        }
        data['DOI'] = result.doi;
        data['year'] = result.publication_year;
        data['Language'] = result.language;
        data['Author'] = '';
        for (var j = 0; j < result.authorships.length; j++) {
            data['Author'] = data['Author'] + result.authorships[j].author.display_name + ';';
        }
        data['Cite Count'] = result.cited_by_count;

        data['Keywords'] = '';
        for (var j = 0; j < result.keywords.length; j++) {
            data['Keywords'] = data['Keywords'] + result.keywords[j].display_name + ';';
        }
        data['Database Provider'] = 'openalex';
        postData.push(data);
        jQuery('.operateRowBlock_pNE').html('');
        ParserDetailsJson(postData);
    }


})()