// 打包请求信息
function packMsgReq(type, data) {
    return {
        uuid: function() {
            return 'generate-uuid-4you-seem-professional'.replace(
                /[genratuidyosmpfl]/g,
                function(c) {
                    const r = Math.random() * 16 | 0,
                        v = c === 'x' ? r : (r & 0x3 | 0x8);
                    return v.toString(16);
                });
        }(),
        type: type,
        data: data,
        timestamp: Date.now()
    };
}

/**
 *目录结构构建
 */
const NEDiretoryTree = {
    // 重新绘制目录树
    ReBuild: function(data) {
        $('#pathRoot').attr('pathFull_Str', data);        
        if (data != 'empty') {
            function _saveClickID(dbname, id, title) {
                chrome.storage.local.set({
                    lastClickItem: {
                        'dbname': dbname,
                        'id': id,
                        'title': title
                    },

                }, function () {
                    console.log('保存成功');
                })
            }
            function _getClickID(storageName, selectDBName) {
                chrome.storage.local.get(storageName, function (result) {
                  if (chrome.runtime.lastError) {
                    console.error(chrome.runtime.lastError);
                  } else {
                    // 检查是否存在键名
                    if (storageName in result) {
                        let id = result[storageName]['id']
                        let title = result[storageName]['title']
                        let dbname = result[storageName]['dbname']
                        if ($("#titleDBName_pNE").text() == dbname) {
                            console.log('Value currently is ', dbname, id, title)
                            $('#pathBlock_pNE').attr('save_data', id);
                            $('#treeNode_pNE').attr('data-file-id', id);
                            $('.pathFileName_pNE').text(title);
                        }
                    } else {
                      console.log(storageName + " 不存在");
                    }
                  }
                })
            }
            let defaultFileID = -3
            let defaultPid = -2
            // 获取路径数据
            var fileData = JSON.parse(data);
            var pathStr = this.TreeHtml(fileData.files, defaultPid);
            // 重置数据库名称
            $('#titleDBName_pNE').html(fileData.dbname[0]);
            $('#pathBlock_pNE').attr('save_data', defaultFileID);
            // 构建路径树DOM
            $('.pathContent_pNE').html(pathStr);
            _getClickID('lastClickItem', fileData.dbname[0], defaultFileID)

            // 对样式进行调整
            for (var i = 0; i < $('.treelist_pNE ').length; i++) {
                if (i == 0) {
                    $('.treelist_pNE ').eq(i).css('marginLeft', '0px');
                }
                if ($('.treelist_pNE ').eq(i).html() == '') {
                    $('.treelist_pNE ').eq(i).prev().find('.treeIcon_pNE').addClass('treeNoChildre_pNE');
                } else {
                    $('.treelist_pNE ').eq(i).prev().find('.treeIcon_pNE').addClass('hasChildNode_pNE');
                }
                if ($('.treelist_pNE ').eq(i).hasClass('none')) {
                    $('.treelist_pNE ').eq(i).hide();
                }
            }
            // 目录树事件绑定
            $('.hasChildNode_pNE').on('click', function() {
                if ($(this).parent().next().is(':visible')) {
                    $(this).removeClass('openTree_pNE');
                    $(this).parent().next().hide();
                } else {
                    $(this).addClass('openTree_pNE');
                    $(this).parent().next().show();
                }
            });
            $('.treeTitle_pNE').on('click', function() {
                let id = $(this).parent().attr('data-file-id')
                let title = $(this).text()
                let dbname = $("#titleDBName_pNE").text()
                _saveClickID(dbname, id, title)

                $('#pathBlock_pNE').attr('save_data', $(this).parent().attr('data-file-id'));
                $('.pathFileName_pNE').text($(this).text());
                NEDiretoryTree.CollapseDirectory();
            })
        } else {
            $('#pluginDialogOfNE').hide();
            alert('请在NE客户端中打开数据库');
        }
    },
    // 目录显示控制按钮
    CollapseDirectory: function() {
        if ($('.pathContent_pNE').is(':visible')) {
            $('.pathContent_pNE').hide();
            $('.rightTriangle_pNE').hide();
            $('.pathTreeShowwBtn_pNE').html('&lt;&nbsp;展开');
        } else {
            $('.pathContent_pNE').show();
            $('.rightTriangle_pNE').show();
            $('.pathTreeShowwBtn_pNE').html('&gt;&nbsp;收起');
        }
    },
    GetLevelById: function(data, id) {
        return this.GetParents(data, id).length;
    },
    TreeHtml: function(fileData, fileId) {
        var _html = '';
        var children = this.GetChildById(fileData, fileId);
        var hideChild = fileId > 0 ? 'none' : '';
        _html += '<ul class="treelist_pNE ' + hideChild + '">';
        children.forEach(function(item, index) {
            var level = NEDiretoryTree.GetLevelById(fileData, item.id);
            var hasChild = NEDiretoryTree.HasChilds(fileData, item.id);
            var className = hasChild ? '' : 'treeNode-empty';
            // var treeRoot_cls = item.id == tools.GetDefault() ? 'treeNode-cur' : '';
            var treeRoot_cls = item.id == NEDiretoryTree.GetDefault() ? 'treeNode-cur' : '';
            _html += `
                <li>
                  <div class="treeNode_pNE ${className} ${treeRoot_cls}" data-file-id="${item.id}">
                    <i class="treeIcon_pNE"></i>
                    <span class="treeTitle_pNE">${item.title}</span>
                  </div>
                  ${NEDiretoryTree.TreeHtml(fileData, item.id)}
                </li>`;
        });
        _html += '</ul>';
        return _html;
    },
    GetParents: function(data, currentId) {
        var arr = [];
        for (var i = 0; i < data.length; i++) {
            if (data[i].id == currentId) {
                arr.push(data[i]);
                arr = arr.concat(this.GetParents(data, data[i].pid))
                break;
            }
        }
        return arr;
    },
    GetDefault: function() {
        if ($('.treeNode-cur').length > 1) {
            return $('.treeNode-cur')[0].attr('data-file-id');
        } else {
            return $('#DirectoryPath').attr('data-file-id');
        }
    },
    HasChilds: function(data, id) {
        return this.GetChildById(data, id).length !== 0;
    },
    GetChildById: function(arr, pid) {
        var newArr = [];
        for (var i = 0; i < arr.length; i++) {
            if (arr[i].pid == pid) {
                newArr.push(arr[i]);
            }
        };
        return newArr;
    },
    Init: function(){
        // 添加对插件对话框区域
        var pluginDialogEle = document.createElement('div');
        pluginDialogEle.id = 'pluginDialogOfNE';
        pluginDialogEle.className = 'pluginDialogBackBlock';
        pluginDialogEle.style = 'display:block';
        var pluginDialogBack = document.createElement('div');
        pluginDialogBack.id = 'pluginDialogBlock_NE';
        pluginDialogBack.className = 'pluginDialogBlock';
        var pluginPathBlock = document.createElement('div');
        pluginPathBlock.id = 'pathBlock_pNE';
        pluginPathBlock.className = 'pathBlock_pNE';
        var pluginSaveBlock = document.createElement('div');
        pluginSaveBlock.id = 'saveBlock_pNE';
        pluginSaveBlock.className = 'saveBlock_pNE';
        var crossUrlBtn = document.createElement('input');
        crossUrlBtn.id = 'crossUrlBtn_pNE';
        crossUrlBtn.className = 'crossUrlBtn_pNE';
        var crossDataBtn = document.createElement('input');
        crossDataBtn.id = 'crossDataBtn_pNE';
        crossDataBtn.className = 'crossDataBtn_pNE';

        pluginDialogBack.appendChild(pluginPathBlock);
        pluginDialogBack.appendChild(pluginSaveBlock);
        pluginDialogEle.appendChild(pluginDialogBack);
        pluginDialogEle.appendChild(crossDataBtn);
        pluginDialogEle.appendChild(crossUrlBtn);
        document.body.appendChild(pluginDialogEle);
        var eachPathNode = document.createElement('input');
        eachPathNode.type = 'hidden';
        eachPathNode.className = 'pathConstructEle';
        eachPathNode.id = 'pathRoot';
        document.getElementById('pathBlock_pNE').appendChild(eachPathNode);
        // 创建目录结构
        extensionDir = chrome.runtime.getURL("");
        var pathTreeHtmlStr = `
            <div class="titleBlock_pNE">
                <img src="` + extensionDir + `images/NE_LOGO.png" class="logoImg_pNE">
                <span id="titleDBName_pNE"></span>
                <img src="` + extensionDir + `images/refresh.png" class="refreshBtn_pNE">
                <img src="` + extensionDir + `images/menu.png" class="availableListBtn_pNE">
                <img src="` + extensionDir + `images/close.png" class="closeBtn_pNE">
            </div>
            <div class="pathCheck_pNE">
                <span class="pathTreeShowwBtn_pNE">&lt;&nbsp;展开</span>
                <span class="pathTitleWord_pNE">保存到：</span>
                <span class="pathFileName_pNE">References</span>
            </div>
            <div class="rightTriangle_pNE"></div>
            <div class="pathContent_pNE">
                
            </div>
        `;
        $('#pluginDialogBlock_NE').append(pathTreeHtmlStr);
    },
    ShowInstallGuide: function() {
        // 添加对插件对话框区域
        var pluginDialogEle = document.createElement('div');
        pluginDialogEle.id = 'pluginGuideDialogOfNE';
        pluginDialogEle.className = 'pluginGuideDialogBackBlock';
        pluginDialogEle.style = 'display:block';
        var pluginDialogBack = document.createElement('div');
        pluginDialogBack.id = 'pluginDialogBlock_NE';
        pluginDialogBack.className = 'pluginDialogBlock';
 
        pluginDialogEle.appendChild(pluginDialogBack);
        document.body.appendChild(pluginDialogEle);
        extensionDir = chrome.runtime.getURL("");
        var pathTreeHtmlStr = `
            <div class="titleBlock_pNE">
                <img src="` + extensionDir + `images/NE_LOGO.png" class="logoImg_pNE">
                <span id="titleDBName_pNE"></span>
                <img src="` + extensionDir + `images/refresh.png" class="refreshBtn_pNE">
                <img src="` + extensionDir + `images/menu.png" class="availableListBtn_pNE">
                <img src="` + extensionDir + `images/close.png" class="closeBtn_pNE">
            </div>
 
            <div class="loadNoteExpress_pNE" id = "loadNoteExpress_pNE">
                正在启动NoteExpress，请稍后...
            </div>

 
            <div class="guide_pNE">
                <div class="guideItem_pNE">
                    本插件需要配合<b>NoteExpress文献管理工具</b>使用
                </div>
                <div class="guideItem_pNE">
                    <div class="run_pNE" id="run_pNE">
                      运行NE
                    </div>
                    <a class="downUrl_pNE" href="https://www.inoteexpress.com/aegean/" target="_blank">下载NoteExpress</a>
                </div>
                <div class="guideItem_pNE">
                    运行后，请刷新插件重新获取信息
                </div>
            </div>
 

        `;

        jQuery('.closeBtn_pNE').bind('click', function () {
            jQuery('#pluginGuideDialogOfNE').hide();
        });
        $('#pluginDialogBlock_NE').append(pathTreeHtmlStr);
        jQuery('.refreshBtn_pNE').bind('click', function () {
            NEClient.ActiveDialog();
        });
        jQuery('.availableListBtn_pNE').bind('click', function () {
            alert('启动NoteExpress, 刷新之后开放此功能');
        }); 
    }

}

const NEDialog = {
    UpdateDirectoryData: function(Data) {
        if (Data != undefined) {
            if (NEController.CheckStruchDataIsValid(Data)) {
                NEDiretoryTree.ReBuild(Data);
            } else {
                NEDiretoryTree.ReBuild('empty');
            }

        } else {
            NEDiretoryTree.ReBuild('empty');
        }        
    },
    Init: function(data) {
        NEDiretoryTree.Init();
        NEDialog.UpdateDirectoryData(data);        
    },
    Show: function() {
        NEDiretoryTree.CollapseDirectory();
    },
    SavingDataAnimate: function() {
        $('#saveBlock_pNE').hide();
        $('#saveBlockDisable_pNE').show();
        $('#savingWaitBlock_pNE').prev().hide();
        $('#savingWaitBlock_pNE').show();
    },
    CloseSavingDataAnimate: function() {
        $('#saveBlock_pNE').show();
        $('#saveBlockDisable_pNE').hide();
        $('#savingWaitBlock_pNE').prev().show();
        $('#savingWaitBlock_pNE').hide();
    },
    Hide: function() {
        if (document.getElementById('pluginDialogOfNE') && (document.getElementById('pluginDialogOfNE').style.display == 'block')) {
            document.getElementById('pluginDialogOfNE').style.display = 'none';
        }
    },
    HideGuide: function() {
        var element = document.getElementById('pluginGuideDialogOfNE');
        if (element) {
            element.remove();
        } else {
            console.log('Element with ID "publicBtnAddEvent" not found.');
        }

        if (document.getElementById('pluginGuideDialogOfNE') && (document.getElementById('pluginGuideDialogOfNE').style.display == 'block')) {
            document.getElementById('pluginGuideDialogOfNE').style.display = 'none';
        }
    },
    ShowInstallGuide: function() {
        NEDiretoryTree.ShowInstallGuide();
        if (document.getElementById('pluginGuideDialogOfNE') && (document.getElementById('pluginGuideDialogOfNE').style.display == 'none')) {
            document.getElementById('pluginGuideDialogOfNE').style.display = 'block';
        };
        if (document.getElementById('contentBlock_pNE') && (document.getElementById('contentBlock_pNE').style.display == 'none')) {
            document.getElementById('contentBlock_pNE').style.display = 'block';
        }
    },
}

const NEController = {
    BootApp: function() {
        NEDialog.Hide();
        location.href = 'NoteExpress://openNE';
    },
    SwichDialog: function() {
        // 检查对话框是否显示
        if (document.getElementById('pluginDialogOfNE').style.display == 'block') {
            NEDialog.Hide();
        } else {
            document.getElementById('pluginDialogOfNE').style.display = 'block';
            if (document.getElementById('pluginDialogOfNE')) {
                jQuery('.refreshBtn_pNE').click();
            }
        }
    },
    ShowInstallGuide: function() {
        if (document.getElementById('pluginDialogOfNE').style.display == 'block') {
            NEDialog.Hide();
        } else {
            document.getElementById('pluginDialogOfNE').style.display = 'block';
            if (document.getElementById('pluginDialogOfNE')) {
                jQuery('.refreshBtn_pNE').click();
            }
        }
    },
    CheckStruchDataIsValid: function(data) {
        return data.indexOf('"dbname"') > 0;
    }
}

function InjectJSAndFirePageReconize() {
    // 添加JS库
    var libFile = document.createElement('script');
    libFile.type = 'text/javascript';
    libFile.src = chrome.runtime.getURL("") + 'js/lib/NELib.js';
    libFile.onload = function() {
        var url = chrome.runtime.getURL("");
        var evt = document.createEvent("CustomEvent");
        evt.initCustomEvent("startWork", true, true, url);
        document.dispatchEvent(evt);
    };
    document.body.appendChild(libFile);
}

const NEClient = {
    ActiveDialog: function() {
        return new Promise((resolve, reject) => {
            chrome.runtime.sendMessage(packMsgReq('checkNEOpened', {}),
                (response) => {
                    if (response.state) {
                        NEDialog.HideGuide();
                        var responseData = response.data.body.split(' = ')[1];                                            
                        // resolve(response.data);
                        // 检查是否有插件弹框
                        if ((responseData != undefined) && NEController.CheckStruchDataIsValid(responseData)) {
                            if (document.getElementById('pluginDialogOfNE')) {
                                NEDialog.UpdateDirectoryData(responseData);
                                NEController.SwichDialog();
                            } else {
                                NEDialog.Init(responseData);
                                InjectJSAndFirePageReconize();

                                // 绑定展开收起按钮事件
                                $('.pathTreeShowwBtn_pNE').on('click', function() {
                                    NEClient.ShowDirectoryBox();
                                });

                                $('.pathTitleWord_pNE').on('click', function() {
                                    NEClient.ShowDirectoryBox();
                                });
                                $('.pathFileName_pNE').on('click', function() {
                                    NEClient.ShowDirectoryBox();
                                });
                                


                                document.getElementById('saveBlock_pNE').addEventListener('click', function() {
                                    NEClient.SaveData();
                                });

                                // 绑定跨域通道监听
                                $('#crossUrlBtn_pNE').on('click', function() {
                                    NEClient.CrossUrl($('#crossUrlBtn_pNE').attr('save_data'));
                                });                                
                            }
                        } else {
                            //NEDialog.HideGuide();      
                            if (document.getElementById('pluginGuideDialogOfNE')) {
                                document.getElementById('loadNoteExpress_pNE').innerText = '请使用3.6.0.9232以上版本的NE作为数据库';
                            }
                            alert('请使用3.6.0.9232以上版本的NE作为数据库');
                        }
                    } else {
                        // if runing tip is show, change tip and exit
                        if (document.getElementById('pluginGuideDialogOfNE')) {
                            jQuery('#pluginGuideDialogOfNE').show();
                        }
                        if (document.getElementById('pluginGuideDialogOfNE')) {
                            document.getElementById('loadNoteExpress_pNE').innerText = '未检测到已打开的NoteExpress…';
                            console.log('未检测到已打开的NoteExpress…');
                            return;
                        }
                        //show Install Guide
                        NEDialog.ShowInstallGuide();
                        document.getElementById('run_pNE').addEventListener('click', function() {
                            NEController.BootApp();
                        });                       
                        setTimeout(function() {
                            NEClient.ActiveDialog();
                        }, 10000);
                    }
                    console.log(response);
                });
        });
    },
    CrossUrl: function() {
        return new Promise((resolve, reject) => {
            chrome.runtime.sendMessage(packMsgReq('crossUrl', { targetUrl: $('#crossUrlBtn_pNE').attr('save_data') }),
                (response) => {
                    if (response.state) {
                        $('#crossDataBtn_pNE').attr('save_data', response.data.body);
                        $('#crossDataBtn_pNE').click();
                    } else {
                        // reject(response.data);
                        $('#crossDataBtn_pNE').attr('save_data', 'wrongData');
                        $('#crossDataBtn_pNE').click();
                    }
                    console.log(response);
                });
        });
    },  

    ShowDirectoryBox: function() {
        return new Promise((resolve, reject) => {
            chrome.runtime.sendMessage(packMsgReq('checkNEOpened', { url: "http://127.0.0.1:49527/GetReference" }),
                (response) => {
                    if (response.state) {
                        // resolve(response.data);
                        var responseData = response.data.body.split(' = ')[1];
                        NEDialog.UpdateDirectoryData(responseData);
                        NEDialog.Show();
                    } else {
                        NEController.BootApp()
                    }
                    console.log(response);
                });
        });
    },
    SaveToNE: function(data, targetdir) {
        NEDialog.SavingDataAnimate();        
        return new Promise((resolve, reject) => {
            chrome.runtime.sendMessage(packMsgReq('saveToNE', { data: data, dir: targetdir }),
                (response) => {
                    switch (response.requestType) {
                        // 保存失败
                        case '0':
                            alert(response.msg);
                            NEDialog.CloseSavingDataAnimate();
                            break;
                            // 保存成功
                        case '1':
                            if ($('input[name="selectItem_pNE"]').length != 0) {
                                $('input[name="selectItem_pNE"]').prop('checked', false);
                                $('input[name="selectAll_pNE"]').prop('checked', false);
                                $('#saveBlock_pNE').attr('save_data', 'empty');
                            }
                            NEDialog.CloseSavingDataAnimate();
                            break;
                        default:
                            console.log('wrong saving popup receive!');
                            NEDialog.CloseSavingDataAnimate();
                    }
                });
        });
    },
    SaveFullTextToNE: function(data, targetdir, pdfPath) {
        NEDialog.SavingDataAnimate();                
        return new Promise((resolve, reject) => {
            chrome.runtime.sendMessage(packMsgReq('saveFullTextToNE', { data: data, dir: targetdir, pdfPath}),
                (response) => {
                    if (!response) {
                        NEDialog.SavingDataAnimate();
                    }
                    switch (response.requestType) {
                        // 保存失败
                        case '0':
                            alert(response.msg);
                            NEDialog.CloseSavingDataAnimate();
                            break;
                            // 保存成功
                        case '1':
                            if (response.downmsg){
                                alert(response.msg);
                            }
                            if ($('input[name="selectItem_pNE"]').length != 0) {
                                $('input[name="selectItem_pNE"]').prop('checked', false);
                                $('input[name="selectAll_pNE"]').prop('checked', false);
                                $('#saveBlock_pNE').attr('save_data', 'empty');
                            }
                            NEDialog.CloseSavingDataAnimate();
                            break;
                        default:
                            console.log('wrong saving popup receive!');
                            NEDialog.CloseSavingDataAnimate();
                    }
                });
        });
    },
    SaveData: function() {
        return new Promise((resolve, reject) => {
            chrome.runtime.sendMessage(packMsgReq('checkNEOpened', { url: "http://127.0.0.1:49527/GetReference", Behaviour: 'saveBlock_pNE' }),
                (response) => {
                    if (response.state) {

                        var saveType = '';
                        var pdfPath = '';
                        // 获取数据
                        if ($('.downloadFullEle_pNE[name="downloadFull_pNE"]').length != 0 && $('.downloadFullEle_pNE[name="downloadFull_pNE"]').is(':checked')) {
                            var data = document.getElementById('saveBlock_pNE').getAttribute('save_fulldata');
                            pdfPath = document.getElementById('saveBlock_pNE').getAttribute('pdfDownloadPath');
                            saveType = 'saveFullTextToNE';
                        } else {
                            var data = document.getElementById('saveBlock_pNE').getAttribute('save_data');
                            saveType = 'saveToNE';
                        }
                        // 获取路径id
                        var targetdir = document.getElementById('pathBlock_pNE').getAttribute('save_data');
                        if (data != 'empty') {
                            if (saveType == 'saveToNE') {
                                NEClient.SaveToNE(data, targetdir)
                            } else {
                                NEClient.SaveFullTextToNE(data, targetdir, pdfPath)
                            }
                        } else {
                            alert('请勾选要保存的记录');
                        }
                    } else {
                        NEController.BootApp();
                    }
                });
        });
    }
}

chrome.runtime.onMessage.addListener(
    function(message, sender, sendResponse) {
        console.log(sender.tab ?
            "from a content script:" + sender.tab.url :
            "from the extension");

        switch (message.greeting) {
            case "NEplugin":
                sendResponse({ farewell: "goodbye" });
                NEClient.ActiveDialog();
                break;

            case "HidePlugWhenTabUpdate":
                NEDialog.Hide();
                break;
            default:
                console.log('wrong request string!');
        }
    }
);

console.log('script.js is loadded')